;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Winders Studio
;;  Copyright (C) 2022 Kevin Serna García, Nerea Pérez Ayestarán, Javier José Botella Rico
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------



.include "entity.h.s"
.include "cpctelerafuncs.h.s"
.include "globales.h.s"



reserve_bytes = 2

    ld ix,#-reserve_bytes
    add ix,sp
    ld sp,ix

;;Numero de posiciones de memoria que reservamos
_entidades::
    .ds 340

;;Puntero a la siguiente entidad
_m_next_free_entity::
    .ds 2

;; Tamanyo entidad


;; Nº entidades que creamos
;num_entidades =  3 Lo he puesto en el .h.s, es lo mismo


;;aqui habra que poner valores distintos porque ya no es para estrellas
;;sino para el sprite, y ahora tenemos tambien velocidad Y
_player_template::
    .db #0x01           ;; Tipo
    .db #0x23           ;; X    
    .db #0x3A           ;; Y
    .db #0x00           ;; VX
    .db #0x00           ;; VY
    .db #0x03           ;; Vida
    .db #SP_PLAYER_W     ;; Ancho sprite
    .db #SP_PLAYER_H     ;; Alto sprite
    .dw #_sp_player      ;; Sprite (2 bytes)
    .db #0x23           ;; Puntero ultima pos X    
    .db #0x3A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x50           ;; Shot timer
    .db #0x00           ;; Puntuacion

_spawn_template::
    .db #0x04           ;; Tipo
    .db #0x10           ;; X    
    .db #0x99           ;; Y
    .db #0x00           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_SPAWN_W     ;; Ancho sprite
    .db #SP_SPAWN_H     ;; Alto sprite
    .dw #_sp_spawn_pixel      ;; Sprite (2 bytes)
    .db #0x10           ;; Puntero ultima pos X    
    .db #0x6F           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0xF0           ;; Shot timer
    .db #0x01           ;; Puntuacion

_shot_template::
    .db #0x03           ;; Tipo
    .db #0x56           ;; X    
    .db #0x12           ;; Y
    .db #0x00           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_SHOT_W      ;; Ancho sprite
    .db #SP_SHOT_H      ;; Alto sprite
    .dw #_sp_shot       ;; Sprite (2 bytes)
    .db #0x56           ;; Puntero ultima pos X    
    .db #0x12           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template::
    .db #0x02           ;; Tipo
    .db #0x1D           ;; X    
    .db #0xA5           ;; Y
    .db #0x00           ;; VX
    .db #0xFE           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W     ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H     ;; Alto sprite
    .dw #_sp_enemy_ghost      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion
    
_enemy_template_2::
    .db #0x02           ;; Tipo
    .db #0x1D           ;; X    
    .db #0xA5           ;; Y
    .db #0x00           ;; VX
    .db #0xFE           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W   ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H    ;; Alto sprite
    .dw #_sp_enemy_ghost      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_3::
    .db #0x02           ;; Tipo
    .db #0x2A           ;; X    
    .db #0x15           ;; Y
    .db #0x00           ;; VX
    .db #0x02           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W     ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H     ;; Alto sprite
    .dw #_sp_enemy_ghost      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_4::
    .db #0x02           ;; Tipo
    .db #0x40           ;; X    
    .db #0x6D           ;; Y
    .db #0xFF           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W   ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H    ;; Alto sprite
    .dw #_sp_enemy_ghost_der      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_5::
    .db #0x02           ;; Tipo
    .db #0x06           ;; X    
    .db #0xA5           ;; Y
    .db #0x01           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W     ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H     ;; Alto sprite
    .dw #_sp_enemy_ghost      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_6::
    .db #0x02           ;; Tipo
    .db #0x30           ;; X    
    .db #0xA5           ;; Y
    .db #0x00           ;; VX
    .db #0xFE           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W   ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H    ;; Alto sprite
    .dw #_sp_enemy_ghost_der      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_7::
    .db #0x02           ;; Tipo
    .db #0x35           ;; X    
    .db #0xA5           ;; Y
    .db #0x00           ;; VX
    .db #0xFE           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W     ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H     ;; Alto sprite
    .dw #_sp_enemy_ghost_der      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_8::
    .db #0x02           ;; Tipo
    .db #0x3E           ;; X    
    .db #0xA5           ;; Y
    .db #0x00           ;; VX
    .db #0xFE           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W   ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H    ;; Alto sprite
    .dw #_sp_enemy_ghost_der      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_9::
    .db #0x02           ;; Tipo
    .db #0x40           ;; X    
    .db #0x8D           ;; Y
    .db #0xFF           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W     ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H     ;; Alto sprite
    .dw #_sp_enemy_ghost_der      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_10::
    .db #0x02           ;; Tipo
    .db #0x40           ;; X    
    .db #0x46           ;; Y
    .db #0xFF           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W   ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H    ;; Alto sprite
    .dw #_sp_enemy_ghost_der      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_11::
    .db #0x02           ;; Tipo
    .db #0x06           ;; X    
    .db #0x18           ;; Y
    .db #0x01           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W     ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H     ;; Alto sprite
    .dw #_sp_enemy_ghost      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_12::
    .db #0x02           ;; Tipo
    .db #0x40           ;; X    
    .db #0x8C           ;; Y
    .db #0xFF           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_CALABAZA_W   ;; Ancho sprite
    .db #SP_ENEMY_CALABAZA_H    ;; Alto sprite
    .dw #_sp_enemy_calabaza      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x01           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x03           ;; Puntuacion

_enemy_template_13::
    .db #0x02           ;; Tipo
    .db #0x06           ;; X    
    .db #0x18           ;; Y
    .db #0x01           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_CALABAZA_W     ;; Ancho sprite
    .db #SP_ENEMY_CALABAZA_H     ;; Alto sprite
    .dw #_sp_enemy_calabaza      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x01           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x03           ;; Puntuacion

_enemy_template_14::
    .db #0x02           ;; Tipo
    .db #0x1D           ;; X    
    .db #0xA4           ;; Y
    .db #0x00           ;; VX
    .db #0xFE           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W   ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H    ;; Alto sprite
    .dw #_sp_enemy_ghost      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

_enemy_template_15::
    .db #0x02           ;; Tipo
    .db #0x06           ;; X    
    .db #0xA4           ;; Y
    .db #0x01           ;; VX
    .db #0x00           ;; VY
    .db #0x01           ;; Vida
    .db #SP_ENEMY_GHOST_W     ;; Ancho sprite
    .db #SP_ENEMY_GHOST_H     ;; Alto sprite
    .dw #_sp_enemy_ghost      ;; Sprite (2 bytes)
    .db #0x35           ;; Puntero ultima pos X    
    .db #0x4A           ;; Puntero ultima pos Y
    .db #0x01           ;; ai_aim_x
    .db #0x01           ;; ai_aim_y
    .db #0x00           ;; ai_status
    .db #0x01           ;; Shot timer
    .db #0x01           ;; Puntuacion

 ;; Reservamos memoria y ponemos las posiciones a 0
_man_entity_init::
    ld hl,#0x00AA ;;Número de posiciones que iniciamos
    push hl
    xor a,a ;;Número al que inicializamos las posiciones de memoria (en este caso 0)
    push af
    inc sp
    ld hl,#_entidades ;;Posición de memoria en la que empezamos a inicializar
    push hl
    call _cpct_memset
    ;;
    ld hl,#_entidades+0
    ld (_m_next_free_entity),hl ;;Hacemos que el puntero de siguiente entidad apunte a la primera posición

    ret



_man_entity_create::
    ld bc,(_m_next_free_entity) ;;Ponemos en bc la posición de la siguiente entidad vacía
    ;;
    ld hl,#size_of_e
    add hl,bc
    ld (_m_next_free_entity),hl ;;Avanzamos el puntero hasta la siguiente entidad vacía
    ;;
    ld l,c
    ld h,b
    ld (hl),#0x7F ;;Inicializamos el tipo de la entidad a default
    ret


;; Le debe llegar en hl que tipo de entidad se crea
;; 0001 para el player , 0002 para el enemigo , 0003 para una bala
;; 0004 para el spawn  , 0005 para el spawn2  , 0006 para el spawn3
;; 0007 para el spawn4 , 0008 para el enemigo2, 0009 para el enemigo3
;; 000A para el enemigo4
_createEntity::
    
    ld a,l
    sub a,#0x01
    jr nz, #_not_player

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_player_template  
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_player:
    sub a,#0x01
    jr nz, #_not_spawn
    
    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_spawn_template  
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_spawn:
    sub a,#0x01
    jr nz,#_not_shot

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_shot_template  
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create
    
    _not_shot:
    sub a,#0x01
    jr nz,#_not_enemy

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template  
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy:
    sub a,#0x01
    jr nz,#_not_enemy_2

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_2
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_2:

    sub a,#0x01
    jr nz,#_not_enemy_3

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_3
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_3:
    ;;;;;;;;;;;;;;;;;;;; HL 0007
    sub a,#0x01
    jr nz,#_not_enemy_4

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_4
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_4:

    sub a,#0x01
    jr nz,#_not_enemy_5

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_5
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_5:

    sub a,#0x01
    jr nz,#_not_enemy_6

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_6
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create
    
    _not_enemy_6:

    sub a,#0x01
    jr nz,#_not_enemy_7

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_7
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create
    
    _not_enemy_7:

    sub a,#0x01
    jr nz,#_not_enemy_8

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_8
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_8:

    sub a,#0x01
    jr nz,#_not_enemy_9

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_9
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_9:

    sub a,#0x01
    jr nz,#_not_enemy_10

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_10
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_10:

    sub a,#0x01
    jr nz,#_not_enemy_11

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_11
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_11:

    sub a,#0x01
    jr nz,#_not_enemy_12

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_12
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_12:

    sub a,#0x01
    jr nz,#_not_enemy_13

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_13
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_13:

    sub a,#0x01
    jr nz,#_not_enemy_14

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_14
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _not_enemy_14:

    call _man_entity_create
    ld de,#size_of_e
    push de
    ld hl,#_enemy_template_15
    push hl  
    push bc
    call _cpct_memcpy ;;Inicializamos los datos de la entidad
    jp _finish_create

    _finish_create:

    ;;DE indica la posición de memoria de la siguiente entidad
    ;;dec de
    ;;dec de
    ;;dec de
    ;;dec de
    ;;dec de
    ;;dec de
    ;;dec de
    ;;push de
    ;;call _cpct_getRandom_mxor_u8
    ;;pop de
    ;;ld a,l
    ;;ld (de),a ;;Cambiamos el valor de e->y por el número generado aleatoriamente
    ret

_man_entity_forall::

    ;;Empezamos el bucle en la primera entidad
    ld bc,#_entidades
    ;;Guardamos en ix la primera entidad
    ;;ld ix, #_entidades

    _while:
    ld l,c
    ld h,b
    ld a,(hl)
    sub a,#0x00 ;;Comprobamos si el tipo de la entidad es correcto. De lo contrario, sale del bucle
    jr z,_end_while

    ex de,hl
    jp (hl) ;;Saltamos a la posición de memoria de la función a la que tenemos que llamar

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;_DESTROYED:
    ;;           INPUT = IX -> Entidad
    _destroyed:
    ;;Ponemos en BC la posición de la siguiente entidad
    ld l,c
    ld h,b
    ld de,#size_of_e
    add hl,de
    ld c,l
    ld b,h
  
    ld de, #size_of_e   ;; / Cargamos la siguiente entidad en IX
    add ix, de          ;; \
   
    pop de
    jr _while

    _end_while:

    ret





;;Pasarle como parámetro Entity* dead_e
;;Nos llega el dead_e en bc
_man_entity_destroy::
    
    ld hl,(_m_next_free_entity)
    push de
    ld de,#0xFFEF
    add hl,de
    pop de

    ld (_m_next_free_entity),hl
    
    ld a,h
    sub a,b
    jr nz,_destroy_not_last

    ld a,l
    sub a,c
    jr z,_destroy_last

    _destroy_not_last:
    ld de,#0x0011
    push de
    ld hl,(_m_next_free_entity)
    push hl
    push bc
    call _cpct_memcpy
    
    jr _destroy_last
    ret

    _destroy_last:
    ld hl,(_m_next_free_entity)
    ld (hl),#0x00
    pop de
    ld b,d
    ld c,e
    jp _update_destroy
    ret


_man_entity_set4destruction::

    ld a,(de)
    or #0x80
    ld (de),a
    jp (hl)    

    ret


_man_entity_update::

    ld bc,#_entidades
    ld e,c
    ld d,b
    
    _update_destroy:

    ld a,(de)
    cp #0

    jr z,_end_update_destroy

    sub a,#0x82
    jr nz,_else_update_destroy
    push de
    jr _man_entity_destroy

    _else_update_destroy:

    push hl
    ld hl,#size_of_e

    add hl,de

    ld e,l
    ld d,h
    
    pop hl

    ld c,e
    ld b,d
    
    jr _update_destroy

    _end_update_destroy:

    ret

_man_entity_getArray::

    ld ix, #_entidades      ;;cargo en ix el sitio donde empiezan las entidades
    ld a, #0x13     ;;cargo en a el numero de entidades
    ret


_man_shoot::

    ld hl,#_entidades
    ld de,#15
    add hl,de ;;e->timer
    ld a,(hl)
    sub a,#0x50
    jr nz,_not_shoot_timer

    ld (hl),#0x49

    ld hl,#0x03
    call _createEntity
    ld hl,(_m_next_free_entity)
    ld a,#16
    _shoot_loop:
    dec hl
    sub a,#1
    jr nz,_shoot_loop

    ;;;;Ahora mismo hl = e->x del shot

    push hl
    ld hl,#_entidades
    inc hl
    ld a,(hl)
    add a,#0x04
    pop hl
    ld (hl),a
    inc hl

    ;;;;Ahora mismo hl = e->y del shot

    push hl
    ld hl,#_entidades
    inc hl
    inc hl
    ld a,(hl)
    add a,#0x04
    pop hl
    ld (hl),a

    ;; Velocidad X

    inc hl
    inc hl
    ld de,#_entidades
    inc de
    inc de
    inc de
    inc de
    ld a,(de)
    sub a,#0x00
    jr z,_not_vy_shot

    ld a,#0x00
    ex de,hl
    add a,(hl)
    ex de,hl
    jp m,_vy_neg_shot

    ld (hl),#6

    jp _not_vy_shot

    _vy_neg_shot:

    ld (hl),#-6

    _not_vy_shot:

    dec de
    dec hl
    ld a,(de)
    sub a,#0x00
    jr z,_shoot_default  

    ld a,#0x00
    ex de,hl
    add a,(hl)
    ex de,hl
    jp m,_vx_neg_shot

    ld (hl),#3    

    jp _not_shoot_timer

    _vx_neg_shot:

    ld (hl),#-3    

    jp _not_shoot_timer

    _shoot_default:

    inc hl
    inc de
    ld a,(de)
    sub a,#0x00
    jr nz,_not_shoot_timer

    dec hl
    ld (hl),#3

    _not_shoot_timer:

    ret



_man_update_timer::


    ld hl,#_entidades
    ld de,#15
    add hl,de ;;e->timer
    ld a,(hl)
    sub a,#0x50
    jr z,_timer_set

    sub a,#1
    jr z,_timer_0
    ld (hl),a
    jp _timer_set

    _timer_0:
    ld a,#0x50
    ld (hl),a

    _timer_set:

    ret


_man_destroy_all_entities::

    ld hl,#_entidades

    _destroy_all_entities:

    ld a,(hl)
    cp #0
    jr z,_end_destroy_all_entities

    ld (hl),#0x82
    ld de,#size_of_e
    add hl,de

    

    jr _destroy_all_entities

    _end_destroy_all_entities:

    ret


_man_create_spawn::

    ld hl,#0x02
    call _createEntity
    ;ld hl,#0x05
    ;call _createEntity
    ;ld hl,#0x06
    ;call _createEntity
    ;ld hl,#0x07
    ;call _createEntity

    ret

;; El spawn nos llega en DE
_man_spawn_timer::

    ld a,(de)
    sub a,#0x04
    jr nz,_spawn_timer_set

    ld hl,#15
    add hl,de ;;e->timer
    ld a,(hl)
    

    sub a,#1
    jr z,_spawn_timer_0
    ld (hl),a
    jp _spawn_timer_set

    _spawn_timer_0:

    push hl
    push de

    ld hl,#_entidades
    ld de,#0x10
    add hl,de
    ld a,(hl)
    sub a,#0x010 ;;;;;;;;;;;;;;;;;;;;;, A PARTIR DE ESTA PUNTUACION AUMENTA LA DIFICULTAD
    jp p,_aumenta_dificultad

    pop de
    pop hl

    ld a,#0x60
    ld (hl),a

    jp _spawn_timer_set

    _aumenta_dificultad:
    
    pop de
    pop hl

    sub a,#0x10
    jp p,_aumenta_dificultad_2

    ld a,#0x40 ;;;;;;;;;;;;;;;;;; BAJAR PARA AUMENTAR LA DIFICULTAD, SUBIR PARA DISMINUIR LA DIFICULTAD
    ld (hl),a

    jp _spawn_timer_set

    _aumenta_dificultad_2:

    ld a,#0x20 ;;;;;;;;;;;;;;;;;; BAJAR PARA AUMENTAR LA DIFICULTAD, SUBIR PARA DISMINUIR LA DIFICULTAD
    ld (hl),a

    _spawn_timer_set:
    ld de,#_man_spawn_timer ;;Volvemos a poner en el registro DE la posicion de memoria de la funcion
    push de 
    jp _destroyed

    ret

_man_all_spawn_timer::
    ld de,#_man_spawn_timer ;;Guardamos en el registro DE la posición de memoria de la funcion _sys_physics_update_one_entity
    call _man_entity_forall
    ret

;; El spawn nos llega en DE
_man_spawn_generate_enemy::

    ld a,(de)
    sub a,#0x04
    jr nz,_end_spawn_generate

    push hl
    push de

    ;;Hacemos que no cree más de 4 enemigos
    ld hl,#_entidades
    ld a,#0x00
    push af
    _conteo_entidades:
    pop af
    add a,#0x01
    ld de,#0x11
    add hl,de
    push af
    ld a,(hl)
    cp #0
    jr nz,_conteo_entidades
    pop af
    pop de
    pop hl

    sub a,#0x05
    jp p,_end_spawn_generate

    ld hl,#15
    add hl,de
    
    ld a,(hl)
    sub a,#0x10
    jr nz,_end_spawn_generate

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Randomizar el spawn
    call _cpct_getRandom_mxor_u8
    ld a,#0x0F
    and l
    add a,#0x04
    ld l,a
    ld h,#0x00
    call _createEntity
   

    _end_spawn_generate:
    ld de,#_man_spawn_generate_enemy ;;Volvemos a poner en el registro DE la posicion de memoria de la funcion
    push de 
    jp _destroyed

    ret

_man_all_spawn_generate_enemy::
    ld de,#_man_spawn_generate_enemy ;;Guardamos en el registro DE la posición de memoria de la funcion _sys_physics_update_one_entity
    call _man_entity_forall
    ret

_man_subir_puntuacion::

    ;;En hl nos llega la e->tipo del enemigo
    ld d,h
    ld e,l
    push de
    ld hl,#_entidades
    ld de,#0x10
    add hl,de
    pop de

    push hl
    ld hl,#0x10
    add hl,de
    ld d,h
    ld e,l
    pop hl

    ;;Ahora en hl tenemos la posicion de memoria donde tenemos que poner los nuevos puntos
    ;;En de tenemos el e->puntuacion
    ex de,hl
    ld a,(de)
    add a,(hl)
    daa
    ld (de),a

    ret
