;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Winders Studio
;;  Copyright (C) 2022 Kevin Serna García, Nerea Pérez Ayestarán, Javier José Botella Rico
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "man/entity.h.s"
.include "cpctelera.h.s"

.module sys_ai_control


;;; SYS AI CONTROL:: INIT
;; Inits the AI control system
;; INPUT:
;;      IX = Pointer to the entity array

sys_ai_control_init::

    ;;; TEMPORAL, HABRA QUE BORRARLO
    ld (_ent_array_ptr_temp_standby), ix

    ld (_ent_array_ptr), ix ;;cargo en _ent_array_ptr lo que tengo en ix
    ret



;;; SYS AI CONTROL:: UPDATE
;;  Updates all AI entities
;;  INPUT:
;;      IX = Pointer to the entity array
;;      A = Number of elements in the array
;; DESTORYS: AF, BC, DE, IX
;; STACK USE: 2 Bytes

sys_ai_stand_by::
_ent_array_ptr_temp_standby = .+2
    ld iy, #0x0000

;; PARA QUE EL ENEMIGO TE PERSIGA SIEMPRE, COMENTAR ESTAS 3 LINEAS
    ld a, e_ai_aim_x(iy)
    or a
    ret z

;;Pressed key. Move to player
    ld a, e_x(iy)
    ld e_ai_aim_x(ix), a
    ld a, e_y(iy)
    ld e_ai_aim_y(ix), a
    ld e_ai_status(ix), #e_ai_st_move_to

    ret

    ;ld e_vx(ix), #-1
    ;ld e_vy(ix), #1

sys_ai_move_to::

    ;ld e_vx(ix), #-1
    ;ld e_vy(ix), #1

    ;;   UPDATE X
    ;ld c, #0
    ;; if (obj_x - x > 0) .....
    ;; Aqui voy a comparar si mi x y la x objetivo es la misma
    ld a, e_ai_aim_x(ix)        ;; A = obj_x
    sub e_x(ix)                 ;; A = obj_x - x
    jr nc, _objx_greater_or_equal        ;; if (obj_x - x > 0) objx_greater (si no hay acarreo es que la x objetivo es mayor que la x)
_objx_lesser:
        ;; si estoy aqui significa que obj_x es menor que x asi que voy hacia la izquierda
        ld e_vx(ix), #-1
        jr _endif_x
_objx_greater_or_equal:
        jr z, _arrived_x        ;; si la resta de antes sale 0, obj_x y x son iguales asi que salto a arrived x
        ;; si no son iguales significa que obj_x es mayor que x entonces me muevo a la derecha
        ld e_vx(ix), #1
        jr _endif_x
_arrived_x:
        ld e_vx(ix), #0
        ;ld c, #1

        ;ld e_ai_status(ix), #e_ai_st_stand_by
_endif_x:
    
    ;;   UPDATE Y
    ;; if (obj_y - y > 0) .....
    ;; Aqui voy a comparar si mi y y la y objetivo es la misma
    ld a, e_ai_aim_y(ix)        ;; A = obj_y
    sub e_y(ix)                 ;; A = obj_y - y
    jr nc, _objy_greater_or_equal        ;; if (obj_y - y > 0) objy_greater (si no hay acarreo es que la y objetivo es mayor o igual que la y)
_objy_lesser:
        ;; si estoy aqui significa que obj_y es menor que y asi que voy hacia la izquierda
        ld e_vy(ix), #-2
        jr _endif_y
_objy_greater_or_equal:
        jr z, _arrived_y        ;; si la resta de antes sale 0, obj_y y y son iguales asi que salto a arrived y
        ;; si no son iguales significa que obj_y es mayor que y entonces me muevo a la derecha
        ld e_vy(ix), #2
        jr _endif_y
_arrived_y:
        ld e_vy(ix), #0
        ld a, e_vx(ix)
        or a
        ;ld a, c
        ;or a
        jr nz, _endif_y

        ;; X y Y son las dos 0
        ld e_ai_status(ix), #e_ai_st_stand_by
_endif_y:
    ret



sys_ai_control_update::
    ;;cargo el numero de entidades (que lo tengo en a) en _ent_counter
    ld (_ent_counter), a
_ent_array_ptr = . + 2
    ld ix, #0x0000 ;; 4 bytes

_loop:

    ;;Cojo el valor que hay en e_ai_status y lo comparo con e_ai_st_noAI(su valor esta en entity.h.s, es 0 basicamente) para ver si la entidad tiene ia o no
    ld a, e_ai_status(ix)
    cp #e_ai_st_noAI
    jr z, _no_AI_ent ;Si la entidad no tiene ia, salto a _no_AI_ent para no actualizarla

_AI_ent:
    
    cp #e_ai_st_stand_by
    call z, sys_ai_stand_by
    cp #e_ai_st_move_to
    call z, sys_ai_move_to
    ;ld e_vx(ix), #-1
    ;ld e_vy(ix), #1
_no_AI_ent:
_ent_counter = . +1
    ld a, #0
    dec a
    ret z

    ld (_ent_counter), a
    ;;esto para pasar a la siguiente entidad
    ld de, #size_of_e 
    add ix, de

    jr _loop