;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Winders Studio
;;  Copyright (C) 2022 Kevin Serna García, Nerea Pérez Ayestarán, Javier José Botella Rico
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "input.h.s"
.include "cpctelerafuncs.h.s"
.include "cpctelera.h.s"

.globl sys_input_init


sys_input_init::
ret


;; Input: 
;; IX = Pointer to entity[0] (el player)
;; destroys: AF, BC, DE, HL, IX
sys_input_update::

    push af
    call cpct_scanKeyboard_f_asm
    pop af
    sub a,#0x01
    jr z,_only_menu

    sub a,#0x01
    jr z,_game_over_input

    ;; Reset velocities
    ld ix,#_entidades

    ld e_vx(ix), #0
    ld e_vy(ix), #0

    ;;Scan the keyboard
    
    call gameKey

    ret

_only_menu:

    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr z, _menu

    ld a,#0x01
    _menu:
    ret
_game_over_input:

    ld hl, #Key_G
    call cpct_isKeyPressed_asm
    jr z, _gameov

    ld a,#0x01
    _gameov:

    ret

gameKey:

    ;; Check for movement keys
    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    jr z, O_NotPressed

;;He puesto OP y QA para moverse porque he visto que en 
;;amstrad eran los controles que se usaban en vez de wasd
;;O es moverse a la izq
O_Pressed:
;; si la o esta pulsada, ponemos velocidad X a -1
        ;;ld e_sprite, #sp_sprite_izq lo de #sp_sprite_izq seria a sustituir con el nombre que se le ponga
        ld e_vx(ix), #-1
O_NotPressed:
;;si no, miramos la P
    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    jr z, P_NotPressed

;;P es moverse a la derecha
P_Pressed:
;; si la P esta pulsada, ponemos velocidad X a 1
        ;;ld e_sprite, #sp_sprite_der lo de #sp_sprite_der seria a sustituir con el nombre que se le ponga
        ld e_vx(ix), #1
        
P_NotPressed:
;;si no, miramos la Q
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr z, Q_NotPressed

Q_Pressed:
;; si la Q esta pulsada, ponemos velocidad y a -2
        ld e_vy(ix), #-2
Q_NotPressed:
;;si no, miramos la A
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr z, A_NotPressed

A_Pressed:
;; si la A esta pulsada, ponemos velocidad Y a 2
        ld e_vy(ix), #2
A_NotPressed:
;;y ret al final
    ld hl, #Joy0_Up
    call cpct_isKeyPressed_asm
    jr z, Joy0_Up_NotPressed
Joy0_UpPressed:
;; si la A esta pulsada, ponemos velocidad Y a 2
        ld e_vy(ix), #-2
Joy0_Up_NotPressed:
;;y ret al final
    ld hl, #Joy0_Down
    call cpct_isKeyPressed_asm
    jr z, Joy0_Down_NotPressed
Joy0_DownPressed:
;; si la A esta pulsada, ponemos velocidad Y a 2
        ld e_vy(ix), #2
Joy0_Down_NotPressed:
;;y ret al final
    ld hl, #Joy0_Left
    call cpct_isKeyPressed_asm
    jr z, Joy0_Left_NotPressed

Joy0_LeftPressed:
;; si la A esta pulsada, ponemos velocidad Y a 2
        ld e_vx(ix), #-1
Joy0_Left_NotPressed:
;;y ret al final
    ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm
    jr z, Joy0_Right_NotPressed

Joy0_RightPressed:
;; si la A esta pulsada, ponemos velocidad Y a 2
        ld e_vx(ix), #1
Joy0_Right_NotPressed:
;;y ret al final
    ld hl, #Key_M
    call cpct_isKeyPressed_asm
    jr z, M_NotPressed

M_Pressed:
;; Si la M esta pulsada, disparamos
    call _man_shoot

M_NotPressed:
    ;ret
    ;;;;;;;Lo de la tecla L es una cosa provisional para hacer pruebas con la IA, despues la quitare
    ld e_ai_aim_x(ix), #0
    ld hl, #Key_L
    call cpct_isKeyPressed_asm
    jr z, L_NotPressed

L_Pressed:
;; si la A esta pulsada, ponemos velocidad Y a 2
        ld e_ai_aim_x(ix), #1
L_NotPressed:
    ret




