;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Winders Studio
;;  Copyright (C) 2022 Kevin Serna García, Nerea Pérez Ayestarán, Javier José Botella Rico
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "physics.h.s"


;;Le pasamos por parámetro un Entity_t* e
;;Nos llega el e en DE
_sys_physics_update_one_entity::

    
    

    ;;Calculamos que no colisione con los border de la pantalla

    call _sys_physics_move

    _cont_border_collision_y:
    
    dec hl ;;e->x
    dec hl ;;e->tipo
    ld a,(hl)
    sub a,#0x03
    jp nz, _not_shot_collision

    inc hl ;;e->x
    ld a,(hl)
    sub a,#0x50
    dec hl ;;e->tipo
    jp m,_cont_shot_collision

    ld (hl),#0x82

    jp _not_shot_collision

    _cont_shot_collision:

    inc hl ;;e->x
    ld a,(hl) ;;Guardamos e->x en a
    inc hl ;;e->y
    inc hl ;;e->vx
    sub a,(hl) ;;Restamos a e->x la velocidad e->vx
    dec hl ;;e->y
    dec hl ;;e->x
    dec hl ;;e->tipo
    jp p,_cont_shot_collision_2

    ld (hl),#0x82

    jp _not_shot_collision

    _cont_shot_collision_2:

    inc hl ;;e->x
    inc hl ;;e->y
    ld a,(hl)
    sub a,#0xB8 
    dec hl ;;e->x
    dec hl ;;e->tipo
    jr nz,_comp_bot_collision

    ld (hl),#0x82

    jp _not_shot_collision

    _comp_bot_collision:

    add a,#0xB8
    sub a,#0xB9

    jr nz,_comp_bot_collision_2

    ld (hl),#0x82

    jp _not_shot_collision

    _comp_bot_collision_2:

    add a,#0xB9
    sub a,#0xBA

    jr nz,_cont_shot_collision_3

    ld (hl),#0x82

    jp _not_shot_collision

    _cont_shot_collision_3:

    inc hl ;;e->x
    inc hl ;;e->y
    ld a,(hl) 
    sub a,#0x02 ;;Comprobamos si hay colisión de la bala con la parte superior de la pantalla
    dec hl ;;e->x
    dec hl ;;e->tipo
    jr nz,_comp_bot_collision_3 

    ld (hl),#0x82

    jp _not_shot_collision

    _comp_bot_collision_3:

    sub a,#0x01
    jr nz,_comp_bot_collision_4

    ld (hl),#0x82

    jp _not_shot_collision

    _comp_bot_collision_4:

    sub a,#0x01
    jr nz,_cont_shot_collision_4

    ld (hl),#0x82

    jp _not_shot_collision

    _cont_shot_collision_4:

    ld de,#_entidades
    
    
    ;; Ahora mismo ix = e->tipo player || hl = e->tipo bala
    _loop_shot_collision:

    ex de,hl
    push de
    ld de,#0x0011
    add hl,de
    pop de
    
    ld a,(hl)
    ex de,hl
    cp #0 ;; Comprobamos si quedan entidades por comprobar
    jr z,_not_shot_collision ;; Si no quedan, termina el bucle
    sub a,#0x02
    jr nz,_loop_shot_collision ;; Si la entidad no es un enemigo, se pasa a la siguiente
    
    inc hl ;;bala->x
    inc de ;;enemigo->x
    
    ld a,(hl) ;;
    ex de,hl
    sub a,(hl) ;;Restamos a la posicion x de la bala la posicion x del enemigo
    ex de,hl
    
    jp p,_enemigo_antes 
    
    ;;Bala antes

    ld a,(hl)
    push de
    ld de,#0x05
    add hl,de
    pop de
    add a,(hl) ;;a = x+w bala
    ex de,hl
    sub a,(hl) ;;a =x+w(bala) - x(enemigo)
    ex de,hl
    push de
    ld de,#0xFA
    add hl,de
    pop de
    dec de ;;enemigo->tipo
    jp m,_loop_shot_collision ;;Si el resultado es positivo, pasamos a la siguiente comprobación, si no, volvemos al principio del bucle

    jp _same_x

    _enemigo_antes:

    ;; hl bala->x || de enemigo->x
    ex de,hl 
    ld a,(hl) ;;a = enemigo->x 
    ex de,hl
    inc de ;;enemigo->y
    inc de ;;enemigo->vx
    inc de ;;enemigo->vy
    inc de ;;enemigo->vida
    inc de ;;enemigo->w
    ex de,hl
    add a,(hl) ;;a = x+w(enemigo)
    ex de,hl
    sub a,(hl) ;;a = x+w(enemigo) - x(bala)
    dec hl ;;bala->tipo
    dec de ;;enemigo->vida
    dec de ;;enemigo->vy
    dec de ;;enemigo->vx
    dec de ;;enemigo->y
    dec de ;;enemigo->x
    dec de ;;enemigo->tipo
    jp m,_loop_shot_collision ;;Si el resultado es positivo, pasamos a la siguiente comprobación, si no, volvemos al principio del bucle

    _same_x:

    ;;Ya hemos calculado que las x coinciden, ahora toca las y
    ;; hl = e->tipo bala || ix = e->tipo enemigo
    inc hl  ;;e->x bala
    inc hl  ;;e->y bala
    ld a,(hl)
    inc de  ;;e->x enemigo
    inc de  ;;e->y enemigo
    ex de,hl
    sub a,(hl) ;;a = y(bala) - y(enemigo)
    ex de,hl
    jp p,_enemigo_arriba 


    ;;Bala arriba
    ;; hl = e->y bala || de = e->y enemigo
    ld a,(hl) ;;a = y(bala)
    push de
    ld de,#0x05
    add hl,de
    pop de
    add a,(hl) ;;a = y+h(bala)
    ex de,hl
    sub a,(hl) ;;a = y+h(bala) - y(enemigo)
    ex de,hl
    dec de ;;enemigo->x
    dec de ;;enemigo->tipo

    push de
    ld de,#0xFFF9
    add hl,de
    pop de

    jp m,_loop_shot_collision

    jp _shot_collision

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    _enemigo_arriba:

    ;;hl = e->y bala || de = e->y enemigo
    ex de,hl
    ld a,(hl) ;;a = y(enemigo)
    ex de,hl
    inc de ;;enemigo->vx
    inc de ;;enemigo->vy
    inc de ;;enemigo->vida
    inc de ;;enemigo->w
    inc de ;;enemigo->h
    ex de,hl
    add a,(hl) ;;a = y+h(enemigo)
    ex de,hl
    sub a,(hl) ;;a = y+h(enemigo) - y(bala)
    dec hl ;;bala->x
    dec hl ;;bala->tipo
    dec de ;;enemigo->w
    dec de ;;enemigo->vida
    dec de ;;enemigo->vy
    dec de ;;enemigo->vx
    dec de ;;enemigo->y
    dec de ;;enemigo->x
    dec de ;;enemigo->tipo
    jp m,_loop_shot_collision

    _shot_collision:

    ;;hl = e->tipo bala || de = e->tipo enemigo
   
    ld (hl),#0x82
    ex de,hl
    ld (hl),#0x82

    call _man_subir_puntuacion
    
    _not_shot_collision:

    ;;push hl
    ;;ld hl,#_setted_4destruction
    ;;jp m,#_man_entity_set4destruction ;;Si el resultado da negativo, destruimos la entidad (habrá salido de la pantalla)
    
    ;;_setted_4destruction:
    ;;pop hl

    ld de,#_sys_physics_update_one_entity ;;Volvemos a poner en el registro DE la posicion de memoria de la funcion
    push de 
    jp _destroyed

    ret

_sys_physics_move::

    ex de,hl
    inc hl ;;;; e->x
    ld e,l 
    ld d,h  ;;de = e->x
    ld a,(hl) ;; a = e->x
    inc hl ;; e->y
    inc hl ;; e->vx
    add a,(hl) ;;sumamos a e->x la e->vx 
    dec hl ;; e->y
    dec hl ;; e->x
    
    push hl
    push af
    ld h,a
    ld a,#0x06 ;;;;;;;;;;;;;;;;;;; CAMBIAR ESTE VALOR PARA CAMBIAR LA COLISION CON EL BORDE IZQUIERDO
    sub a,h
    ;;Tenemos en a la nuevo posicion de e
    jp z,#_border_collision_x

    pop af
    pop hl

    push hl
    push af
    ld h,a
    ld a,#0x05 ;;;;;;;;;;;;;;;;;;; CAMBIAR ESTE VALOR PARA CAMBIAR LA COLISION CON EL BORDE IZQUIERDO
    sub a,h
    
    ;;Tenemos en a la nuevo posicion de e
    jp z,#_border_collision_x

    pop af
    pop hl


    push hl
    push af
    ld h,a
    ld a,#0x04 ;;;;;;;;;;;;;;;;;;; CAMBIAR ESTE VALOR PARA CAMBIAR LA COLISION CON EL BORDE IZQUIERDO
    sub a,h
    
    ;;Tenemos en a la nuevo posicion de e
    jp z,#_border_collision_x

    pop af
    pop hl
    
    ld d,a 
    inc hl
    inc hl
    inc hl
    inc hl
    inc hl
    add a,(hl)
    dec hl
    dec hl
    dec hl
    dec hl
    dec hl
    sub a,#0x4B  ;;;;;;;;;;;;;;;;;;; CAMBIAR ESTE VALOR PARA CAMBIAR LA COLISION CON EL BORDE DERECHO
    ld a,d
    ld d,h
    jp p,_collision_x_50

    ld (hl),a ;;Introducimos en e->x su nuevo valor

    jp _cont_border_collision_x

    _collision_x_50:

    dec hl ;;hl = e->tipo
    ld a,(hl)
    sub a,#0x02
    inc hl
    jr z,_eliminar_ent
    
    sub a,#0x01
    jr nz,_cont_border_collision_x
    
    _eliminar_ent:
    dec hl
    ld (hl),#0x82

    jp _not_shot_collision

     _border_collision_x:

    pop af
    pop hl

    dec hl
    ld a,(hl)
    sub a,#0x02
    inc hl
    jr z,_eliminar_ent_2

    sub a,#0x01
    jr nz,_cont_border_collision_x

    _eliminar_ent_2:
    dec hl
    ld (hl),#0x82

    jp _not_shot_collision

    _cont_border_collision_x:

    ;; Ahora mismo hl = e->x || de = e->x

    inc hl  ;;e->y
    ld a,(hl)
    inc hl  ;;e->vx
    inc hl  ;;e->vy
    add a,(hl)
    inc hl
    inc hl
    inc hl
    sub a,#0x11 ;;;;;;;;;;;;;;;;;;; CAMBIAR ESTE VALOR PARA CAMBIAR LA COLISION CON EL BORDE SUPERIOR
    jp z,_border_collision_y
    
    sub a,#0x01
    jp z,_border_collision_y

    sub a,#0x01
    jp z,_border_collision_y

    sub a,#0x01
    jp z,_border_collision_y
    
    sub a,#0x01
    jp z,_border_collision_y

    sub a,#0x01
    jp z,_border_collision_y

    add a,#0x02
    

    
    dec hl
    dec hl
    dec hl
    dec hl
    dec hl
    dec hl

    _bot_collision:

    ;;hl = e->x
    inc hl ;;e->y
    ld a,(hl)
    inc hl ;;e->vx
    inc hl ;;e->vy
    add a,(hl) ;;sumamos a e->y la e->vy
    inc hl
    inc hl
    inc hl
    add a,(hl)
    
    sub a,#0xBA

    jp z,_border_collision_y

    add a,#0xBA
    sub a,#0xBB

    jp z,_border_collision_y

    add a,#0xBB
    sub a,#0xBC

    jp z,_border_collision_y

    add a,#0xBC
    sub a,#0xBD

    jp z,_border_collision_y

    add a,#0xBD
    sub a,#0xBE

    jp z,_border_collision_y

    add a,#0xBE
    sub a,#0xBF


    jp z,_border_collision_y
     ;;Calculamos que no colisione con el borde superior de la pantalla
     ;;Ya tenemos e->y + e->vy en a    

    add a,#0xBF
    sub a,(hl)
    dec hl
    dec hl
    dec hl
    dec hl
    dec hl
    ld (hl),a ;;Introducimos en e->y su nuevo valor

    jp _cont_border_collision_y
    
    _border_collision_y:
    ;;e->h
    dec hl
    dec hl
    dec hl
    dec hl
    dec hl

    dec hl ;;e->x
    dec hl ;;e->tipo
    ld a,(hl) 
    sub a,#0x02
    inc hl ;;e->x
    inc hl ;;e->y
    jr z,_elim_ent_3

    sub a,#0x01
    jp nz,_cont_border_collision_y

    _elim_ent_3:
    dec hl ;;e->x
    dec hl ;;e->tipo
    ld (hl),#0x82

    jp _not_shot_collision

    ret


_sys_physics_update::
    ld c,#0x01
    ld de,#_sys_physics_update_one_entity ;;Guardamos en el registro DE la posición de memoria de la funcion _sys_physics_update_one_entity
    call _man_entity_forall
    ret


_sys_update_collision_enemies::
    ld de,#_sys_collision_enemies ;;Guardamos en el registro DE la posición de memoria de la funcion _sys_physics_update_one_entity
    call _man_entity_forall
    ret


;;Nos llega la entidad en de
_sys_collision_enemies::

    ld a,(de)
    sub a,#0x02
    jp nz,_finish_collision_enemy

    ld hl,#_entidades

    ;; hl = e->tipo player || de = e->tipo enemigo
    inc hl ;;e->x player
    inc de ;;e->x enemigo
    ld a,(hl) ;;
    ex de,hl
    sub a,(hl) ;;Restamos a la posicion x del player la posicion x del enemigo
    ex de,hl
    
    jp p,_enemy_left 

    ld a,(hl)
    push de
    ld de,#0x05
    add hl,de
    pop de
    add a,(hl) ;;a = x+w player
    ex de,hl
    sub a,(hl) ;;a =x+w(player) - x(enemigo)
    ex de,hl
    push de
    ld de,#0xFFFA
    add hl,de
    pop de
    
    dec de ;;enemigo->tipo
    jp m,_finish_collision_enemy ;;Si el resultado es positivo, pasamos a la siguiente comprobación, si no, acaba la funcion

    jp _same_x_2

    ;;;;;;;;;;;;;;;;;;;;;;

    _enemy_left:

    ;; hl player->x || de enemigo->x
    ex de,hl 
    ld a,(hl) ;;a = enemigo->x 
    ex de,hl
    inc de ;;enemigo->y
    inc de ;;enemigo->vx
    inc de ;;enemigo->vy
    inc de ;;enemigo->vida
    inc de ;;enemigo->w
    ex de,hl
    add a,(hl) ;;a = x+w(enemigo)
    ex de,hl
    sub a,(hl) ;;a = x+w(enemigo) - x(player)
    dec hl ;;player->tipo
    dec de ;;enemigo->vida
    dec de ;;enemigo->vy
    dec de ;;enemigo->vx
    dec de ;;enemigo->y
    dec de ;;enemigo->x
    dec de ;;enemigo->tipo
    jp m,_finish_collision_enemy ;;Si el resultado es positivo, pasamos a la siguiente comprobación, si no, acaba la funcion

    _same_x_2:

    ;;Ya hemos calculado que las x coinciden, ahora toca las y
    ;; hl = e->tipo player || ix = e->tipo enemigo
    inc hl  ;;e->x player
    inc hl  ;;e->y player
    ld a,(hl)
    inc de  ;;e->x enemigo
    inc de  ;;e->y enemigo
    ex de,hl
    sub a,(hl) ;;a = y(player) - y(enemigo)
    ex de,hl
    jp p,_enemy_top 


    ;;player arriba
    ;; hl = e->y player || de = e->y enemigo
    ld a,(hl) ;;a = y(player)
    push de
    ld de,#0x05
    add hl,de
    pop de
    add a,(hl) ;;a = y+h(player)
    ex de,hl
    sub a,(hl) ;;a = y+h(player) - y(enemigo)
    ex de,hl
    dec de ;;enemigo->x
    dec de ;;enemigo->tipo
    push de
    ld de,#0xFFF9
    add hl,de
    pop de
    
    jp m,_finish_collision_enemy

    jp _enemy_collision

    _enemy_top:

    ;;hl = e->y player || de = e->y enemigo
    ex de,hl
    ld a,(hl) ;;a = y(enemigo)
    ex de,hl
    inc de ;;enemigo->vx
    inc de ;;enemigo->vy
    inc de ;;enemigo->vida
    inc de ;;enemigo->w
    inc de ;;enemigo->h
    ex de,hl
    add a,(hl) ;;a = y+h(enemigo)
    ex de,hl
    sub a,(hl) ;;a = y+h(enemigo) - y(player)
    dec hl ;;player->x
    dec hl ;;player->tipo
    dec de ;;enemigo->w
    dec de ;;enemigo->vida
    dec de ;;enemigo->vy
    dec de ;;enemigo->vx
    dec de ;;enemigo->y
    dec de ;;enemigo->x
    dec de ;;enemigo->tipo
    jp m,_finish_collision_enemy

    ;;;;;;;;;;;;;

    _enemy_collision:

    ;;hl = e->tipo player || de = e->tipo enemigo
    push de
    ld de,#0x05
    add hl,de
    pop de
    ld a,(hl)
    push af

    cp #0
    jr z,_vida_0

    pop af
    sub a,#0x01
    
    ld (hl),a
    
    ex de,hl
    ld (hl),#0x82
    jr _finish_collision_enemy

    _vida_0:

    pop af

    _finish_collision_enemy:

    ld de,#_sys_collision_enemies ;;Volvemos a poner en el registro DE la posicion de memoria de la funcion
    push de 
    jp _destroyed

    ret